VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Andmote Server"
   ClientHeight    =   4245
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5835
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4245
   ScaleWidth      =   5835
   StartUpPosition =   1  'CenterOwner
   Begin VB.CheckBox chkTray 
      Caption         =   "Minimize to tray"
      Height          =   255
      Left            =   2040
      TabIndex        =   8
      Top             =   3960
      Width           =   1455
   End
   Begin VB.CheckBox chkStart 
      Caption         =   "Listen on start up"
      Height          =   255
      Left            =   3720
      TabIndex        =   7
      Top             =   3960
      Width           =   1575
   End
   Begin VB.CheckBox chkMinimize 
      Caption         =   "Minimize on start up"
      Height          =   195
      Left            =   0
      TabIndex        =   6
      Top             =   3960
      Width           =   1695
   End
   Begin VB.Timer tmrWinsock 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   3240
      Top             =   120
   End
   Begin MSComctlLib.Slider sldMultiplier 
      Height          =   255
      Left            =   0
      TabIndex        =   5
      Top             =   480
      Width           =   5775
      _ExtentX        =   10186
      _ExtentY        =   450
      _Version        =   393216
      LargeChange     =   1
      Min             =   1
      SelStart        =   3
      Value           =   3
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear Log"
      Height          =   375
      Left            =   4920
      TabIndex        =   4
      Top             =   120
      Width           =   855
   End
   Begin VB.TextBox txtPort 
      Height          =   285
      Left            =   2280
      TabIndex        =   3
      Text            =   "2010"
      Top             =   120
      Width           =   735
   End
   Begin VB.TextBox txtLog 
      Height          =   3015
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   840
      Width           =   5775
   End
   Begin VB.CommandButton cmdServer 
      Caption         =   "Start"
      Height          =   315
      Left            =   0
      TabIndex        =   0
      Top             =   120
      Width           =   975
   End
   Begin MSWinsockLib.Winsock wskServer 
      Left            =   3840
      Top             =   120
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      LocalPort       =   2010
   End
   Begin VB.Label lblPort 
      Caption         =   "TCP Port:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1320
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
'AndmoteServer - 01-2011 - jwbensley@gmail.com
'This is the VB6 desktop end to the Andmote Android App (download at www.jamesbensley.co.cc)
'This program receives X and Y increment values over TCP generated by the touch screen of an Android device
'used to move the cursor of a computer running this program, meaning the Android device can act as a wireless mouse
'
'Also, its 22:20, I absolutely can not be arsed to write an INI reading/writing class right now, I could have written
'a registry class quicker but I don't think I can be bothered with that right now either so thanks to Steve McMahon,
'I'm using your INI file class which is a classic for VB6 lazy bones like me :D
'
'
Option Explicit
Private m_cIni As New cInifile

Public Sub Log(strMessage As String)
'This sub adds the parsed string as a new line in the log box which is date and time stamped
txtLog.Text = txtLog.Text & vbNewLine & Date & "-" & Time & ": " & strMessage
End Sub

Private Sub chkMinimize_Click()
'This sub handles the click event of the "minimize on start up" check box, when its un/ticked,
'update the setting in the INI file
With m_cIni
    .Key = "minimized"
    .Value = chkMinimize.Value
End With
End Sub

Private Sub chkStart_Click()
'This sub handles the click event of the "listen on start up" check box, when its un/ticked,
'update the setting in the INI file
With m_cIni
    .Key = "start"
    .Value = chkStart.Value
End With
End Sub

Private Sub chkTray_Click()
'This sub handles the click event of the "minimize to tray" check box, when its un/ticked,
'update the setting in the INI file
With m_cIni
    .Key = "tray"
    .Value = chkTray.Value
End With
End Sub

Private Sub cmdClear_Click()
'This sub clears our the log box
txtLog.Text = Date & "-" & Time & ": Log Cleared"

End Sub

Private Sub cmdServer_Click()

'If the server isn't already listening...
If cmdServer.Caption = "Start" Then
    wskServer.LocalPort = txtPort
    wskServer.Listen 'Set the port and start listening
    Log ("Server socket listening on " & wskServer.LocalIP & ":" & wskServer.LocalPort)
    tmrWinsock.Enabled = True 'Start the timer which checks for scoket errors and restarts the socket
    cmdServer.Caption = "Stop"
'Else, if the server is running
ElseIf cmdServer.Caption = "Stop" Then
    wskServer.Close 'Close the socket
    Log ("Server socket closed")
    tmrWinsock.Enabled = False 'Stop the socket checking timer
    cmdServer.Caption = "Start" 'Reset this button
End If

End Sub

Private Sub Form_Load()
'Blank out the log box
txtLog.Text = Date & "-" & Time & ": App Started"

With m_cIni 'Lets load up our settings from an INI file
    .Path = App.Path & "\" & App.EXEName & ".ini" 'Stored in the app path as "AndmoteServer.ini"
    .Section = "settings"
    .Key = "minimized"
    .Default = 1
    chkMinimize.Value = .Value 'Set the "minimized on start up" value
    .Key = "tray"
    .Default = 1
    chkTray.Value = .Value 'Set the "minimized to tray" value
    .Key = "start"
    .Default = 0
    chkStart.Value = .Value 'And the "listen on start up" value
    
End With

' These are the tray icon settings
With IconData
    .cbSize = Len(IconData) ' The length of the NOTIFYICONDATA type
    .hIcon = Me.Icon ' A reference to the form's icon
    .hwnd = Me.hwnd ' hWnd of the form
    .szTip = "Andmote" & Chr(0) ' Tooltip string delimited with a null character
    .uCallbackMessage = WM_MOUSEMOVE ' The icon we're placing will send messages to the MouseMove event
    .uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE ' It will have message handling and a tooltip
    .uID = vbNull ' uID is not used by VB, so it's set to a Null value
End With

If chkStart.Value = 1 Then 'And implement these options if they are true
    cmdServer_Click ' So, start listening
End If
If chkMinimize.Value = 1 Then
    Me.WindowState = vbMinimized ' Minimize this window
End If


End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
' This sub handles the event returned from clicking on the tray icon

Dim Msg As Long
Msg = x / Screen.TwipsPerPixelX
' You must set your form's ScaleMode property to pixels in order to get the correct message
If Msg = WM_LBUTTONDOWN Then ' If it was either a left or right click,
    Me.WindowState = vbNormal ' Restore the form
    Shell_NotifyIcon NIM_DELETE, IconData ' and deleted the tray icon
    Me.Show
End If

End Sub

Private Sub Form_Resize()
If Me.WindowState = 1 Then ' If the window is being minimised,
    If chkTray.Value = 1 Then ' And we are set to minimise to tray...
        Call Shell_NotifyIcon(NIM_ADD, IconData) ' Add a tray icon first
        Me.Hide
    End If
End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
Shell_NotifyIcon NIM_DELETE, IconData ' Don't forget to delete the tray icon
End Sub

Private Sub tmrWinsock_Timer()
'This timer checks the state of the Winsock connectionn, if it is in an error state,
'or the remote client has disconnected we will retart the connection

'If the socket has changed to the closing state restart the socket
'This tends to happen if the clients dropps out unexpectedly meaning they
'cant reconnect
If wskServer.State = 8 Then
    Log ("Restarting (client connetion lost)")
    wskServer.Close
    wskServer.Listen
    Log ("Server socket listening on " & wskServer.LocalIP & ":" & wskServer.LocalPort)
End If

'If the socket has changed to the error state restart the socket
If wskServer.State = 9 Then
    Log ("Restarting (socket state is error)")
    wskServer.Close
    wskServer.Listen
    Log ("Server socket listening on " & wskServer.LocalIP & ":" & wskServer.LocalPort)
End If

End Sub

Private Sub wskServer_ConnectionRequest(ByVal requestID As Long)
'This sub handles incomming connection requests

wskServer.Close ' Close the winsock to make sure it is in a ready state (not in a have connected state) for a new connection
wskServer.Accept requestID 'Accept the new connection
Log ("Connection from " & wskServer.RemoteHostIP & ":" & wskServer.RemotePort & " established")

End Sub

Private Sub wskServer_DataArrival(ByVal bytesTotal As Long)

Dim strData As String 'Get the sent data
wskServer.GetData strData

Dim CurrentCoords As POINTAPI
GetCursorPos CurrentCoords

Dim x As Integer, y As Integer
x = Int(CurrentCoords.x) 'Good old VB, from float to int without batting an eye lid :D
y = Int(CurrentCoords.y)

'Check first if it was a shell command sent over first (because we want to check the left three characters it needs to be a seperate statement
If Mid(strData, 1, 3) = "cmd" Then 'If it was the exec the parsed start execept for the first four characters "cmd "
 On Error Resume Next 'This nasty 'On Error' takes care of fat fingers who type in paths to files that aren't actually there in a very lazy way :D
 Log ("Shell: " & Right(strData, Len(strData) - 4))
 Shell Right(strData, Len(strData) - 4), vbNormalFocus
 Exit Sub
End If

Select Case strData
    'Select the send data and evaluate what was send, a command may have been sent rather than the X,Y co-ords, check for these first
    'Else its the co-ords
    
    Case "singleclick" 'Send a single left mouse click to the current X,Y position
    mouse_event MOUSEEVENTF_ABSOLUTE + MOUSEEVENTF_LEFTDOWN + MOUSEEVENTF_LEFTUP, x, y, 0, 0
    Log ("Single click at " & x & "," & y)
    
    Case "rightclick" 'Send a right mouse click to the current X,Y position
    mouse_event MOUSEEVENTF_ABSOLUTE + MOUSEEVENTF_RIGHTDOWN + MOUSEEVENTF_RIGHTUP, x, y, 0, 0
    Log ("Right click at " & x & "," & y)
    
    Case "volup" 'Increment the sensitivity slider
    If sldMultiplier.Value < sldMultiplier.Max Then
        sldMultiplier.Value = sldMultiplier.Value + 1
    End If
    Log ("volup")
    
    Case "voldown" 'Decrement the sensitivity slider
    If sldMultiplier.Value > 1 Then
        sldMultiplier.Value = sldMultiplier.Value - 1
    End If
    Log ("voldown")
    
    Case "taskmgr" 'Start the task manager (by default its in a system variable path, so we don't need to specificy the full path)
    Shell "taskmgr.exe", vbNormalFocus
    Log ("TaskManager started")
    
    Case Else
    'We have an "On Error Resume Next" statement (or cop-out as I call them) here because sometimes the android client sends
    'the x,y co-ords faster than the VB end can process them (this is changeable by recompiling the android source and modifying
    'the lngTick value). Based on my own test the delay of 150ms on the android end avoids 9/10 erros but they did still rarely occur
    'so we have cheated out of dealing with the problem here :) A better solution maybe to lower frequency of X,Y polling on the client
    'but I find any longer than 150ms and its just too jittery when moving the mouse (In my opinion 150 is too long).
    On Error Resume Next
    
    Dim fltX As Long
    Dim fltY As Long
    Dim strSplit() As String
    strSplit = Split(strData, ",") 'If you want to write a better desktop end, the co-ords come in as "x,y" which are two float values
    fltX = strSplit(0)
    fltY = strSplit(1)
    'The values are how much to increment the current X and Y by. So if X is +5 then setting the current X to its self +5,
    'will move the cursor right by 5 pixels. If it were -5, setting the current X value to its self -5 will of course move
    'the cursor left by 5 pixels.
    
    Log ("X=" & CurrentCoords.x & ", +" & (fltX * sldMultiplier.Value) & " = " & (CurrentCoords.x + (fltX * sldMultiplier.Value)))
    Log ("Y=" & CurrentCoords.y & ", +" & (fltY * sldMultiplier.Value) & " = " & (CurrentCoords.y + (fltY * sldMultiplier.Value)))

    'Set the cursor X value to the current X value + (the received value * the sensitivity multiplier). Same for Y value.
    SetCursorPos (CurrentCoords.x + (fltX * sldMultiplier.Value)), (CurrentCoords.y + (fltY * sldMultiplier.Value))
    
End Select

End Sub

Private Sub wskServer_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
'This sub handles socket errors. If there is one, print it out:
Log ("Winsock error: " & Number & " " & Description & " " & Scode & " " & Source)
End Sub


